#!/usr/bin/perl

use IO::Socket;
require 'settings';
require 'mail_settings';

$server = $ARGV[0] || $server_default;
$port = $ARGV[1] || $port_default;
$date = `date`;
chop($date);

$V4ADDR = `/sbin/ifconfig | grep -1 $INTERFACE | cut -s -d ' ' -f12 | grep addr | cut -d ':' -f2`;
chop($V4ADDR);

&intro;
print "- $date -\n";
print "- Host: $V4ADDR -\n";

&connection;
&logging;

#Receive everything the server sends and print it to the screen
while ($line = <$remote>) {
	print "-> $line";
	if ($redirect eq 'ON') {print $remote "PRIVMSG $nick_redirect :$line\n";}
	$line =~ /^:([^ ]+) ([^ ]+) (.+)$/;

	$who = $1;
	$cmd = $2;
	$arg = $3;

	if ($line =~ /^PING :.+$/)
		{
		print $remote "PONG $nick\n";
		print "<- PONG $nick\n";
		}
	else
		{
		if ($cmd eq 'PRIVMSG')
			{
	 		$who =~ /^([^!]+)!(.+)$/;
	 		$nick_request = $1;
	 		$arg =~ /^([^ ]+) :(.+)$/;
	 		$channel_request = $1;
	 		$comando = $2;
			
			#Commands on channel or query (with ! before)
	 		if (($comando =~ /^!(.+)\r$/) && (&control($nick_request) eq "true"))
				{
				if ($1 eq 'quit')
					{
					print $remote "QUIT :$quit_msg\n";
					}
				elsif ($1 eq 'ip')
					{
					if ($channel_request eq $nick)
						{
						print $remote "PRIVMSG $nick_request :Ciao $nick_request, il mio indirizzo ip : $V4ADDR\n";
						}
					else
						{
						print $remote "PRIVMSG $channel_request :Ciao $nick_request, il mio indirizzo ip : $V4ADDR\n";
						}
					}
				elsif ($1 eq 'dns')
  					{
					$dns = `lynx --dump "http://freedns.afraid.org/dynamic/update.php?put_your_code_here="`;
					$dns =~ s/\s+/ /g;
					if ($channel_request eq $nick)
						{
						print $remote "PRIVMSG $nick_request :$dns\n";
						}
					else
						{
						print $remote "PRIVMSG $channel_request :$dns\n";
						}
					}
				elsif ($1 eq 'help')
  					{
					print $remote "PRIVMSG $nick_request :Comandi attivi: tutti i comandi bash preceduti da ! per ottenere l'output in canale o query, tutti i comandi bash preceduti da @ per ottenere l'output in notice, tutti i comandi grezzi irc preceduti da ?. In pi  possibile inviare email seguendo la sintassi !mail destinatario 'testo del messaggio'.\n";
					}
				elsif ($1 eq 'unredirect')
  					{
  					$redirect = 'OFF';
					}
				elsif ($1 =~ /^redirect (.+)$/)
  					{
  					$redirect = 'ON';
  					$nick_redirect = $1;
					}
				elsif ($1 =~ /^mail ([^ ]+) (.+)$/)
  					{
					$subject = 'Messaggio di '.$nick_request." da irc\n";
  					$to = $1;
  					$text = $2;
  					@mail = `perl mail.pl $server_mail_default $port_mail_default $from_default $to '$subject' $text`;
					chop(@mail);
					foreach $linea (@mail)
						{
						if ($channel_request eq $nick)
							{
							print $remote "PRIVMSG $nick_request :$linea\n";
							}
						else
							{
							print $remote "PRIVMSG $channel_request :$linea\n";
							}
						}
					}
				else
  					{
					@cm = `$1`;
					chop(@cm);
					foreach $linea (@cm)
						{
						if ($channel_request eq $nick)
							{
							print $remote "PRIVMSG $nick_request :$linea\n";
							}
						else
							{
							print $remote "PRIVMSG $channel_request :$linea\n";
							}
						}
					}
				}
			
			#Commands on notice (with @ before)
	 		if (($comando =~ /^@(.+)\r$/) && (&control($nick_request) eq "true"))
				{
				if ($1 eq 'quit')
					{
					print $remote "QUIT :$quit_msg\n";
					}
				elsif ($1 eq 'ip')
					{
					print $remote "NOTICE $nick_request :Ciao $nick_request, il mio indirizzo ip : $V4ADDR\n";
					}
				elsif ($1 eq 'dns')
  					{
					$dns = `lynx --dump "http://freedns.afraid.org/dynamic/update.php?put_your_code_here="`;
					$dns =~ s/\s+/ /g;
					print $remote "NOTICE $nick_request :$dns\n";
					}
				elsif ($1 eq 'help')
  					{
					print $remote "NOTICE $nick_request :Comandi attivi: tutti i comandi bash preceduti da ! per ottenere l'output in canale o query, tutti i comandi bash preceduti da @ per ottenere l'output in notice, tutti i comandi grezzi irc preceduti da ?. In pi  possibile inviare email seguendo la sintassi !mail destinatario 'testo del messaggio'.\n";
					}
				else
  					{
					@cm = `$1`;
					chop(@cm);
					foreach $linea (@cm)
						{
						print $remote "NOTICE $nick_request :$linea\n";
						}
					}
				}

			#Raw commands (with ? before)
	 		if (($comando =~ /^\?(.+)\r$/) && (&control($nick_request) eq "true"))
				{
				print $remote "$1\n";
				}
			
			}
		elsif ($cmd eq 'NICK')
			{
	 		$who =~ /^([^!]+)!(.+)$/;
	 		$nick_request = $1;
	 		$arg =~ /^:(.+)$/;
	 		if ($nick_request eq $nick)
				{
				$nick = $1;
				chop($nick);
				}
			}
		elsif ($cmd eq 'KICK')
			{
	 		$arg =~ /^([^ ]+) ([^ ]+) :(.+)$/;
	 		$channel_request = $1;
			print $remote "JOIN $channel_request\n";
			}
		elsif ($cmd eq 'TOPIC')
			{
	 		$arg =~ /^([^ ]+) :(.+)$/;
	 		$channel_request = $1;
			print $remote "PRIVMSG $channel_request :bel topic\n";
			}
		#elsif ($cmd eq 'JOIN')
		#	{
		#	$who =~ /^([^!]+)!(.+)$/;
	 	#	$nick_join = $1;
		#	if ($nick_join ne $nick)
		#		{
		#		print $remote "PRIVMSG $channel :ciao $nick_join\n";
		#		}
		#	}
		}
}

close $remote;


#####################
#Subroutines
#####################
sub intro {
open (FILE, "< $fileintro") || die "Error!\n\n";
while ($line_intro = <FILE>)   {
	print "$line_intro";
	}
}

sub connection {
print "Connecting to irc server $server, port $port... ";
$remote = IO::Socket::INET->new(Proto=>"tcp", PeerAddr=>$server, PeerPort=> $port, Reuse=>1) or die "Connection to  \"$server\", port \"$port\" failed!\n";
# set buffering off
$remote->autoflush(1);
print "done!\n";
print $remote "NICK $nick\n";
print "<- NICK $nick\n";
print $remote "USER $ident 1 2 :$name\n";
print "<- USER $ident 1 2 $name\n";
&perform;
}

sub perform {
print $remote "ns IDENTIFY $identify_pass\n";
print "<- ns IDENTIFY ********\n";
print $remote "JOIN $channel\n";
print "<- JOIN $channel\n";
}

sub control {
$risultato = 'false';
open (FILE, "< $users_list") || die "Error!\n\n";
while ($line_nick = <FILE>)   {
	$line_nick =~ s/\s//g;
	if ($_[0] eq $line_nick)
		{
		print $remote "WHOIS $_[0]\n";
		print "<- WHOIS $_[0]\n";
		while ($line_remote = <$remote>) {
			print "-> $line_remote";
			$line_remote =~ /^:([^ ]+) ([^ ]+) (.+)$/;
			$cmd_control = $2;
			if ($cmd_control eq '307')
				{ $risultato = 'true'; }
			if ($cmd_control eq '318')
				{
				if ($risultato ne "true") { print $remote "NOTICE $_[0] :$_[0] has not identified for this nick\n"; }
				return ($risultato); 
				}
			}
 		}
	}
}

sub logging {
if ($log == 'ON')   {
open (FILE, ">> $logfile") || die "Error!\n\n";
print FILE "- $date - Connection from $ENV{'REMOTE_ADDR'}, port $ENV{'REMOTE_PORT'} to irc server $server, port $port\n";
close(FILE);
}
}
